<template>
    <v-row class="d-flex mb-3">
        <v-col v-for="(field, key) in data" :key="key" :cols="field.colLenght">
            <v-label 
                v-if="field.label"
                class="font-weight-bold mb-1"
            >
                {{ field.label }}
            </v-label>

            <v-dialog 
                v-if="field.addProductButton"
                max-width="500"
            >
                <template v-slot:activator="{ props: activatorProps }">
                    <v-btn
                        v-bind="activatorProps"
                        color="primary" 
                        size="large" 
                        flat
                        class="ml-4 mb-2"
                    >
                        Ajouter un produit
                    </v-btn>
                </template>
        
                <template v-slot:default="{ isActive }">
                    <v-card title="Ajout d'un produit">
                        <v-card-text>
                            Sélectionner le produit à ajouter dans le devis.
                        </v-card-text>

                        <v-card-item>
                            <v-select 
                                v-model="selectedProduct" 
                                variant="outlined" 
                                :items="products?.map((product) => product.nom)" 
                                hide-details 
                                color="primary"
                            ></v-select>
                        </v-card-item>
            
                        <v-card-actions>
                            <v-btn
                                color="primary" 
                                size="large" 
                                flat
                                @click="addToTable(); isActive.value = false;"
                            >
                                Ajouter un produit
                            </v-btn>
                        </v-card-actions>
                    </v-card>
                </template>
            </v-dialog>

            <v-text-field 
                v-if="field.formType === 'text' || field.formType === 'password' || field.formType === 'date'" 
                variant="outlined" 
                v-model="field.value" 
                :type="field.formType" 
                hide-details 
                color="primary"
            ></v-text-field>

            <v-text-field
                v-if="field.formType === 'number'" 
                variant="outlined" 
                v-model="field.value" 
                hide-details
                type="number"
                color="primary"
            />

            <v-select 
                v-if="field.formType == 'select' && (field.items || products)" 
                variant="outlined" 
                v-model="field.value"
                :items="field.items || (products ? products.map((product) => product.nom) : [])" 
                hide-details 
                color="primary"
            ></v-select>

            <v-card 
                v-if="field.formType === 'table'"  
                elevation="10" class=""
            >
                <v-card-item class="py-2 px-4">
                    <v-table 
                        v-if="field.thead && field.tbody && field.tbody.length > 0"
                        class="month-table"
                    >
                        <thead>
                            <tr>
                                <th v-for="(th, key) in field.thead" :key="key" class="text-subtitle-1 font-weight-bold">{{ th }}</th>
                                <th class="text-subtitle-1 font-weight-bold text-right"></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(item, key) in field.tbody" :key="key" class="month-item">
                                <td>
                                    <p class="text-15 font-weight-medium">{{ item.nom }}</p>
                                </td>
                                <td>
                                    <p class="text-15 font-weight-medium">{{ item.description }}</p>
                                </td>
                                <td>
                                    <p class="text-15 font-weight-medium">{{ item.prix }}</p>
                                </td>
                                <td>
                                    <v-row align="center">
                                        <!-- Bouton de décrémentation -->
                                        <v-btn
                                            color="primary"
                                            icon
                                            @click="decrementQuantity(key)"
                                        >
                                            <v-icon>mdi-minus</v-icon>
                                        </v-btn>
                    
                                        <!-- Affichage de la quantité -->
                                        <p class="px-4 text-15 font-weight-medium">{{ item.quantity }}</p>
                    
                                        <!-- Bouton d'incrémentation -->
                                        <v-btn
                                            color="primary"
                                            icon
                                            @click="incrementQuantity(key)"
                                        >
                                            <v-icon>mdi-plus</v-icon>
                                        </v-btn>
                                    </v-row>
                                </td>
                                <td>
                                    <p class="text-15 font-weight-medium">{{ parseFloat(item.prix) * parseFloat(item.quantity) }}</p>
                                </td>
                                <td class="text-right">
                                    <v-btn color="primary" variant="outlined" @click="deleteRow(key)">Supprimer</v-btn>
                                </td>
                            </tr>
                        </tbody>
                    </v-table>
                    <div v-else>
                        <p class="pa-4">
                            Le tableau est vide.
                        </p>
                    </div>
                </v-card-item>
            </v-card>
        </v-col>
    </v-row>
</template>

<script setup lang="ts">
import { defineProps } from 'vue';

const props = defineProps<{
    data: {
        [key: string]: {
            formType: string;
            label: string;
            value: string;
            rules: string;
            colLenght: number;
            items?: string[];
            thead?: string[];
            tbody?: {
                name: string;
                description: string;
                price: string;
                quantity: string;
            }[];
            products?: {
                name: string;
                description: string;
                price: number;
                quantity: number;
            }[];
            addProductButton?: boolean;
        };
    };
}>();

const responseProduits = await fetch('http://localhost:8000/api/produits', {
    method: 'GET',
    headers: {
        'Content-Type': 'application/json',
    }
});
const responseDataProduits = await responseProduits.json();
const products = responseDataProduits['hydra:member'];

const responseClients = await fetch('http://localhost:8000/api/clients', {
    method: 'GET',
    headers: {
        'Content-Type': 'application/json',
    }
});
const responseDataClients = await responseClients.json();
const clients = responseDataClients['hydra:member'];

// Variable pour stocker la valeur sélectionnée dans le v-select
const selectedProduct = ref('');

// Méthode pour supprimer une ligne du tableau
const deleteRow = (key: number) => {
    props.data['productsTable'].tbody.splice(key, 1);
};

// Méthode pour ajouter un produit au tableau
const addToTable = () => {
    if (selectedProduct) {
        // On vérifie si le produit sélectionné existe déjà dans le tableau
        const product = props.data['productsTable'].tbody.find((product) => product.name === selectedProduct.value);
        if (product) {
            // Si le produit existe, on incrémente la quantité
            product.quantity++;
        } else {
            // Sinon, on ajoute le produit au tableau
            props.data['productsTable'].tbody.push({
                id: products.find((product) => product.nom === selectedProduct.value)?.id || '',
                nom: selectedProduct.value,
                description: products.find((product) => product.nom === selectedProduct.value)?.description || '',
                prix: products.find((product) => product.nom === selectedProduct.value)?.prix.toString() || '',
                quantity: '1',
            });
        }
    }
};

// Méthode pour décrémenter la quantité d'un produit
const decrementQuantity = (key: number) => {
    const product = props.data['productsTable'].tbody[key];
    if (product.quantity > 1) {
        product.quantity--;
    }
};

// Méthode pour incrémenter la quantité d'un produit
const incrementQuantity = (key: number) => {
    const product = props.data['productsTable'].tbody[key];
    product.quantity++;
};
</script>
